
Database - Bug #2094

OUTER-JOIN record phrase option not honored

03/15/2013 12:11 PM - Eric Faulhaber

Status: Closed Start date: 03/24/2013

Priority: Normal Due date:  

Assignee: Constantin Asofiei % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Conversion Support for Server Features   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 03/23/2013 10:09 PM - Eric Faulhaber

- Assignee set to Ovidiu Maxiniuc

The following:

define query q1 for person, pers-addr.

open query q1

  for each person where person.emp-num > 0,

  first pers-addr where person.site-id = pers-addr.site-id outer-join no-lock.

 

converts to (relevant portion only):

query0.assign(new CompoundQuery(true, false));

query0.addComponent(new AdaptiveQuery(person, "person.empNum > 0", null, "person.siteId asc, person.empNum asc

"));

RecordBuffer.prepare(persAddr);

query0.addComponent(new RandomAccessQuery(persAddr, "? = persAddr.siteId", null, "persAddr.siteId asc, persAdd

r.empNum asc", new Object[]

{

   new FieldReference(person, "siteId")

}, LockType.NONE), QueryConstants.FIRST);

 

There should be a third parameter -- true -- emitted to the second query0.addComponent call, after QueryConstants.FIRST, indicating that this query

component should be joined via a LEFT OUTER JOIN.
#2 - 03/24/2013 03:15 PM - Constantin Asofiei

- Assignee changed from Ovidiu Maxiniuc to Constantin Asofiei

#3 - 03/24/2013 03:37 PM - Constantin Asofiei

- File ca_upd20130324e.zip added

This update adds support for the OUTER-JOIN clause for a record phrase. The LEFT OUTER-JOIN will not emit anything. It is going through

conversion regression testing now.

LE: LEFT OUTER-JOIN is the same as OUTER-JOIN and will need to convert the same.

#4 - 03/24/2013 03:43 PM - Constantin Asofiei

- File deleted (ca_upd20130324e.zip)

#5 - 03/24/2013 03:47 PM - Constantin Asofiei

- File ca_upd20130324f.zip added

Properly handles the OUTER-JOIN and LEFT OUTER-JOIN to convert the same.

#6 - 03/24/2013 04:04 PM - Constantin Asofiei

- % Done changed from 0 to 70

- Status changed from New to WIP

- Start date set to 03/24/2013

#7 - 03/24/2013 05:03 PM - Eric Faulhaber

Change looks good to me.  Please check in and distribute if/when it passes conversion regression testing.

#8 - 03/24/2013 05:25 PM - Constantin Asofiei

- Status changed from WIP to Review

Passed conversion regression testing, committed to bzr revision 10328. I'll do a separate server folder conversion with this change tomorrow.

#9 - 03/24/2013 05:27 PM - Eric Faulhaber

BTW, location of the original problem is pmplan/gapptfn5.p.cache, line 700.

#10 - 03/29/2013 09:19 AM - Eric Faulhaber

- % Done changed from 70 to 100

- Status changed from Review to Closed

#11 - 11/16/2016 11:06 AM - Greg Shah

- Target version changed from Milestone 4 to Conversion Support for Server Features

Files

ca_upd20130324f.zip 20 KB 03/24/2013 Constantin Asofiei
